
public class CoelhosPD {

    static int[] tabela = new int[0];

    static int contaGeracoes(int n) {

        if (n==1)
            return 1;
        if (n==2)
            return 2;

        if (tabela.length <= n) {
           tabela = new int[2*n+1]; 
           tabela[0] = 1;
           tabela[1] = 1;
           tabela[2] = 2;
        }

        return coelhosPD(n);
    }

    public static int coelhosPD(int n) {

        if (tabela[n] > 0)
            return tabela[n];
        else {
            tabela[n-1] = coelhosPD(n-1);
            tabela[n-2] = coelhosPD(n-2);

            return tabela[n-1]+tabela[n-2];
        }

    }

    
    public static void main(String args[]) {

        long t0 = System.currentTimeMillis();

        for (int n = 1; n <= 45; n++) {
            System.out.println("Numero de coelhos na geracao "+ n + "  "+ contaGeracoes(n) + ".");
        }

        long t1 = System.currentTimeMillis();

        System.out.println("Duracao em ms foi "+(t1-t0));

    }
    

}
